  
"
    __________________________________________________
    @Alejandro F. Reimondo [mailTo:aleReimondo@sugarWeb.com] 01/04/99
    This proyect sources are property of : Alejandro F. Reimondo [mailTo:aleReimondo@sugarWeb.com]
    Its use is NOT legal without written rights.
    Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-1-703-5586.
    __________________________________________________
"!

Dynalink32 variableByteSubclass: #URLMonDLL
  classVariableNames: ''
  poolDictionaries: ''  !


!URLMonDLL class methods !
   
fileName
        "Answer the receiver's file name."

    ^'URLMon.dll'! !



!URLMonDLL methods !

urlDownload: szURL toFile: szFileName
    "Downloads bits from the Internet and saves them to a file.
	Returns true if success."

    [
	self
		urlDownloadToFile: nil
		url: szURL asParameter
		fileName: szFileName asParameter
		reserved: 0
		callback: nil
	] on: APICallError do: [ ^false ].
	^true!

urlDownloadToCache: szURL
    "Downloads data into the Internet cache and returns the name of the cached file.
	Returns nil if a problem occurs."

	| result fileName |
	fileName := String new: 1024.
    [self
		urlDownloadToCacheFile: nil
		url: szURL asParameter
		fileName: fileName
		length: fileName size
		reserved: 0
		callback: nil
	] on: APICallError do: [ ^nil ].
	^fileName trimBlanks!
   
urlDownloadToCacheFile: pCaller
	url: szURL
	fileName: szFileName
	length: szFileNameLen
	reserved: dwResv
	callback: lpfnCB

    "Downloads data into the Internet cache and returns the name of the cached file.
	The client can optionally be notified of progress by means of a notification callback."

    <api: URLDownloadToCacheFileA struct struct struct ulong ulong struct hresult>
    ^self invalidArgument

	"
szFileName : Indirect pointer to the name of the cached file returned by this function. The user should pass a buffer to be filled and, preferably, use MAX_PATH to allocate the maximum path size. 
dwBufLen : The size of the buffer passed in szFileName. 
	"!
 
urlDownloadToFile: pCaller
	url: szURL
	fileName: szFileName
	reserved: dwResv
	callback: lpfnCB

    "Downloads bits from the Internet and saves them to a file.
	The client can optionally be notified of progress by means of a notification callback."

    <api: URLDownloadToFileA struct struct struct ulong struct hresult>
    ^self invalidArgument!

urlOpenBlockingStream: pCaller url: szURL ppStream: ppStream reserved: dwResv callback: lpfnCB

    "URLOpenBlockingStream creates a blocking-type stream object from a URL.
	The data is downloaded from the Internet on demand by a call to IStream::Read.
	The Read call will block until enough data has arrived."

    <api: URLOpenBlockingStreamA struct struct struct ulong struct hresult>
    ^self invalidArgument!
   
urlOpenPullStream: pCaller url: szURL reserved: dwResv callback: lpfnCB

    "Creates a pull-type stream object from a URL."

    <api: URLOpenPullStreamA struct struct ulong struct hresult>
    ^self invalidArgument!
  
urlOpenStream: pCaller url: szURL reserved: dwResv callback: lpfnCB

    "Creates a push-type stream object from a URL.
	The data is downloaded from the Internet as fast as possible.
	Every time data is available, it is pushed at the client through a notification callback. 
	"

    <api: URLOpenStreamA struct struct ulong struct hresult>
    ^self invalidArgument! !
