#if !defined(AFX_VS4THEWEBCTL_H__6EE03435_CF31_11D2_9452_000001252013__INCLUDED_)
#define AFX_VS4THEWEBCTL_H__6EE03435_CF31_11D2_9452_000001252013__INCLUDED_

#include "unzip.h"

#include "vs4web.h"	// Added by ClassView
#include "InstallDlg.h"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// VS4TheWebCtl.h : Declaration of the CVS4TheWebCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CVS4TheWebCtrl : See VS4TheWebCtl.cpp for implementation.

class CVS4TheWebCtrl : public COleControl
{
	DECLARE_DYNCREATE(CVS4TheWebCtrl)

// Constructor
public:
	CVS4TheWebCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVS4TheWebCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CVS4TheWebCtrl();

	DECLARE_OLECREATE_EX(CVS4TheWebCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CVS4TheWebCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CVS4TheWebCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CVS4TheWebCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CVS4TheWebCtrl)
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CVS4TheWebCtrl)
	afx_msg long GetWindowHandle();
	afx_msg void SetWindowHandle(long nNewValue);
	afx_msg BSTR GetReceiver();
	afx_msg void SetReceiver(LPCTSTR lpszNewValue);
	afx_msg BSTR GetSelector();
	afx_msg void SetSelector(LPCTSTR lpszNewValue);
	afx_msg BSTR GetArgument();
	afx_msg void SetArgument(LPCTSTR lpszNewValue);
	afx_msg BSTR GetDo();
	afx_msg void SetDo(LPCTSTR lpszNewValue);
	afx_msg BSTR GetBindings();
	afx_msg void SetBindings(LPCTSTR lpszNewValue);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CVS4TheWebCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	void CloseInstallDialog();
	CInstallDlg installDialog();
	CInstallDlg *m_pInstallDialog;
	void SayLabel(CString aLabel);
	CString m_Label;
	BOOL TransferProperties();
	CString m_Bindings;
	CString m_Do;
	CString m_Argument;
	CString m_Selector;
	CString m_Receiver;
	BOOL isInPath (LPCTSTR fileName);
	BOOL isInstalledPart4();
	BOOL isInstalledPart3();
	BOOL isInstalledPart2();
	BOOL isInstalledPart1();
	BOOL addRegistryEntries();
	BOOL addRegistryEntry(HKEY root, LPCTSTR subKey, LPCTSTR value);
	BOOL makeDir (CString name);
	int do_extract_currentfile(unzFile uf, BOOL* popt_extract_without_path, BOOL* popt_overwrite);
	BOOL doExtract(unzFile uf, BOOL opt_extract_without_path, BOOL opt_overwrite);
	BOOL decompress( CString zipFileName);
	void FormatString2(LPTSTR lpszOut, LPCTSTR lpszFormat, LPCTSTR lpsz1, LPCTSTR lpsz2);
	BOOL installZip( CString name );
	CString m_InstallDirectory;
	BOOL installPart4();
	BOOL installPart3();
	BOOL installPart2();
	BOOL installPart1();
	CString m_installURL;
	BOOL m_Installing;
	BOOL installServer();
	void OnDrawInvalid(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	IVS4WEBDisp GetIVS4WEB();
	BOOL IsVS4WEBValid();
	IVS4WEBDisp m_IVS4WEB;
	enum {
	//{{AFX_DISP_ID(CVS4TheWebCtrl)
	dispidWindowHandle = 1L,
	dispidReceiver = 2L,
	dispidSelector = 3L,
	dispidArgument = 4L,
	dispidDo = 5L,
	dispidBindings = 6L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VS4THEWEBCTL_H__6EE03435_CF31_11D2_9452_000001252013__INCLUDED)
