  
"
    __________________________________________________
    @Alejandro F. Reimondo [mailTo:aleReimondo@sugarWeb.com] 10/04/99
    This proyect sources are property of : Alejandro F. Reimondo [mailTo:aleReimondo@sugarWeb.com]
    Its use is NOT legal without written rights.
    Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-1-703-5586.
    __________________________________________________
"!

ActivexCoordinator subclass: #WEBExample
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

ActivexCoordinator subclass: #TransDemo
  instanceVariableNames: 
    ' image label hasBeenDisplayed '
  classVariableNames: ''
  poolDictionaries: '' !


!WEBExample class methods !
  
buildView: anActivexPane forModel: aCoordinator
    "Create the structure of the window <aView> for the application <aCoordinator>."

    anActivexPane
        when: #button1Down do: [ anActivexPane pen place: anActivexPane mouseLocation ];
        when: #button1Moved do: [anActivexPane pen goto: anActivexPane mouseLocation ];
		when: #display do: [
			anActivexPane erase.
			anActivexPane pen
				displayText: 'Drag the mouse here'
				at: 20@20
		];
		yourself! !



!TransDemo class methods !
  
buildView: anActivexPane forModel: aCoordinator
    "Create the structure of the window <aView> for the application <aCoordinator>."

	| image |
    anActivexPane
		backColor: Color gray;
		when: #display send: #display: to: aCoordinator with: anActivexPane;
		when: #mouseMoved: do: [:aPoint|
			aCoordinator mouseMoveOn: anActivexPane at: aPoint
		]! !



!TransDemo methods !
 
display: anActivexPane
	" Private - Display the receiver in anActivexPane. "

	anActivexPane erase.
	anActivexPane pen
		place: 0@0 + 1;
		box: anActivexPane rectangle rightBottom - 1;
		place: anActivexPane rectangle center;
		centerText: self label asString;
		yourself.
	self hasBeenDisplayed: true.!
   
hasBeenDisplayed
    "Returns the instance var of the receiver
     for external manipulation"

	hasBeenDisplayed isNil ifTrue: [ self initializeHasBeenDisplayed ].
    ^hasBeenDisplayed!

hasBeenDisplayed: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    hasBeenDisplayed := anObject!
   
image
    "Returns the instance var of the receiver
     for external manipulation"

	image isNil ifTrue: [ self initializeImage ].
    ^image!

initializeHasBeenDisplayed
	" Private - Initializes the receiver's hasBeenDisplayed"

	hasBeenDisplayed := false.!
   
initializeImage
	" Private - Initializes the receiver's image"

	| fileName |
	fileName := VS4WEBAutomationServer current findFileName: '256.rle'.
	fileName isNil ifTrue: [ ^Icon runtimeIcon ].
	[ image := self transparentImageSupport fromFile: fileName ] on: Error do: [].
	image isNil ifTrue: [ ^Icon runtimeIcon ].
	^image!
  
initialState: anObject
    "Set the initial state of the receiver to <anObject>."

	super initialState: anObject.
	self label: anObject.!
   
label
    "Returns the instance var of the receiver
     for external manipulation"
    ^label!
  
label: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    label := anObject!
 
mouseMoveOn: anActivexPane at: aPoint
	" Private - Mouse has bee moved to aPoint. "

	self hasBeenDisplayed ifFalse: [ ^self ].
	self image
		displayAt: aPoint - (self image extent // 2)
		with: anActivexPane pen!
 
transparentImageSupport
	" Private - Returns the TransparentImages support class. "

	^Smalltalk
		at: #TransparentImage
		ifAbsent: [ "failed to load Trans SLL"
			window notNil ifTrue: [ window backColor: Color black ].
			DIB
		]! !
